
"""take a C file, extract the docstring, and turn it into
a simple textfile for easy editing"""

import fnmatch

docpattern = '*static char*doc_*=*'

def src2html(infile, outfile):
    global commentpattern
    documents = []

    try:
        if type(infile) == type(''):
            infile = open(infile)
        if type(outfile) == type(''):
            outfile = open(outfile, 'w')
    except IOError:
        raise SystemExit, 'Error: Cannot open files'

    #read source
    while 1:
        line = infile.readline()
        if not line: break
        if fnmatch.fnmatch(line, docpattern) and line.find(';') == -1:
            lines = []
            while 1:
                line = infile.readline()
                if not line or line.find('"') == -1: break
                line = line[line.find('"'):]
                line = line.replace('"', ' ').strip()
                if line[-2:] == '\\n':
                    line = line[:-2]
                lines.append(line)
            documents.append(lines)

    #write html
    print >> outfile, '<html><title>TITLE</title><body>\n'
    for d in documents[:]:
        if d[0].find('(') == -1:
            print >> outfile, '<h1>'
            print >> outfile, '\n'.join(d)
            print >> outfile, '</h1><hr>\n'
            documents.remove(d)

    print >> outfile, '<p><table>\n'
    for d in documents:
        name = d[0][:d[0].find('(')]
        print >> outfile, '<tr><td><li><a href=#'+name+'>\n<b>'+d[0]+'</b></li></a></td>'
        print >> outfile, '<td>- '+d[1]+'</td></tr>\n'
    print >> outfile, '</table></p>\n'

    for d in documents:
        name = d[0][:d[0].find('(')]
        print >> outfile, '<hr><p><a name='+name+'><h2>'+d[0]+'</h2>'
        print >> outfile, '\n'.join(d[3:])+'</p>\n'



if __name__ == '__main__':
    import sys
    try:
        inname = sys.argv[1]
        outname = sys.argv[2]
    except IndexError:
        raise SystemExit, 'USAGE: src2html infile outfile'
    src2html(inname, outname)
